<script setup>
import {onBeforeUnmount, onMounted, onUnmounted, ref, reactive} from "vue";
import {useRouter} from "vue-router"
import {host, WebSocketHost} from '@/utils/constants'
import dayjs from 'dayjs';
import request from "@/utils/request"
import {closeWebSocket, initializeWebSocket} from '@/utils/WebSocketService';
import {ElMessage, ElMessageBox} from 'element-plus'
import {useI18n} from 'vue-i18n'
import { inject } from 'vue';
const globalDate = inject('globalDate');
const {t} = useI18n()
let language = ref(localStorage.getItem('lang') || 'zh')
const tableDataa = ref([])
const tableDatab = ref([])
const tableDatad = ref([])
const adjustedRects = ref([]);
const selectValuesa = reactive([]);
const timeRange = ref([])
const taskState = ref('')
const taskType = ref('')
const glassId = ref('')
const blindb = ref(false)
let socket = null;
const socketUrl = `ws://${WebSocketHost}:${host}/api/cacheGlass/api/talk/cacheGlassTwo`;
const handleMessage = (data) => {
  const cageInfo = data.taskMessage[0];
  if (cageInfo && cageInfo.createTime) {
    cageInfo.formattedCreateTime = formatTimestamp(cageInfo.createTime);
  }
  if (cageInfo && cageInfo.updateTime) {
    cageInfo.formattedupdateTime = formatTimestamp(cageInfo.updateTime);
  }
  tableDataa.value = data.EdgStorageCageinfos[0]
  tableDatab.value = data.taskMessage
  adjustedRects.value = data.EdgStorageCageinfos[0].map((rect, index) => ({  
      ...rect,
      id: rect.id * 9,
      showRect: !!data.EdgStorageCageinfos[0][index]?.details[0]
    })); 
  };
// 格式化后端时间并计算一周前的时间
const defaultTime = ref<[Date, Date]>([new Date(), new Date()]);
function parseAndSetTime() {
  const backendTime = new Date(globalDate);
  const oneWeekAgo = new Date(backendTime.getTime() - 7 * 24 * 60 * 60 * 1000); // 减去7天
  oneWeekAgo.setHours(0, 0, 0, 0);
  timeRange.value = [formatTimestamp(oneWeekAgo), formatTimestamp(backendTime)];
  window.localStorage.setItem('startTime', formatTimestamp(oneWeekAgo))
}
  onMounted(() => {
  socket = initializeWebSocket(socketUrl, handleMessage);
  parseAndSetTime();
});
// 历史任务
const iframeUrl = ref('');
const handlehistorical = (row) => {
  blindb.value = true;
  iframeUrl.value = `${window.location.origin}/#/Caching/cachingunhistory`;
};
const sethistorical = async () => {
  try { 
    const params = {
      deviceId: 2,
      startTime: (timeRange.value && timeRange.value[0]) || '',
      endTime: (timeRange.value && timeRange.value[1]) || '',
      glassId: glassId.value || '',
      taskState: taskState.value,
      taskType: taskType.value || ''
    };
    // 构建查询字符串
    const queryString = new URLSearchParams(params).toString();
    const url = `/cacheGlass/edgStorageDeviceTaskHistory?${queryString}`;
      const response = await request.get(url) 
      if (response.code == 200) {
        ElMessage.success(response.message);
        tableDatad.value = response.data;
      } else {
        ElMessage.error(response.message);
    }
}
catch (error) {
  }
}
// 破损
 const handletake = async(row) => { 
  try {
    const confirmResult = await ElMessageBox.confirm(  
      t('workOrder.messagedamaged'), 
      t('workOrder.prompt'),  
      {  
        confirmButtonText: t('workOrder.yes'), 
        cancelButtonText: t('workOrder.cancel'),
        type: 'warning',  
      } 
    );
    if (confirmResult === 'confirm') {
      const response = await request.post("/cacheGlass/edgStorageCageDetails/edgDetailsOperate", {
        glassId: row.glassId,
        state: 8,
        line: 2,
        workingProcedure: '理片笼',
    })
    if (response.code === 200) {
      ElMessage.success(response.message);
      } else {
      ElMessage.error(response.msg);
      }  
    }  
  } catch (error) {
  }  
};  
// 拿走 
 const handleBindRack = async(row) => {  
  try {
    const confirmResult = await ElMessageBox.confirm(  
      t('workOrder.takemessage'), 
      t('workOrder.prompt'),  
      {  
        confirmButtonText: t('workOrder.yes'), 
        cancelButtonText: t('workOrder.cancel'),
        type: 'warning',  
      } 
    );
    if (confirmResult === 'confirm') {
      const response = await request.post("/cacheGlass/edgStorageCageDetails/edgDetailsOperate", {
        glassId: row.glassId,
        state: 9,
        line: 2,
        workingProcedure: '理片笼',
    })
    if (response.code === 200) {
      ElMessage.success(response.message);
      } else {
      ElMessage.error(response.msg);
      }  
    }  
  } catch (error) {
  }  
}; 
// 任务重置
const handleptask = async() => { 
  try {
    const confirmResult = await ElMessageBox.confirm(  
      t('searchOrder.partasks'), 
      t('workOrder.prompt'),  
      {  
        confirmButtonText: t('workOrder.yes'), 
        cancelButtonText: t('workOrder.cancel'),
        type: 'warning',  
      } 
    );
 if (confirmResult === 'confirm') {
  var url="/cacheGlass/edgStorageDeviceTask/resetTask?deviceId="+ 2;
      const response = await request.post(url) 
    if (response.code === 200) {
      ElMessage.success(response.message);
      } else {
      ElMessage.error(response.msg);
      }  
    }  
  } catch (error) {
  }  
}; 
// 任务成功处理
const successfull = async() => { 
  try {
    const confirmResult = await ElMessageBox.confirm(  
      t('searchOrder.psuccessfullyprocessed'), 
      t('workOrder.prompt'),  
      {  
        confirmButtonText: t('workOrder.yes'), 
        cancelButtonText: t('workOrder.cancel'),
        type: 'warning',  
      } 
    );
 if (confirmResult === 'confirm') {
  var url="/cacheGlass/edgStorageDeviceTask/taskSuccess?deviceId="+ 2;
      const response = await request.post(url) 
    if (response.code === 200) {
      ElMessage.success(response.message);
      } else {
      ElMessage.error(response.msg);
      }  
    }  
  } catch (error) {
  }  
};
 // 删除 
 const handledelete = async(row) => {  
  try {
    const confirmResult = await ElMessageBox.confirm(  
      t('searchOrder.deletemessage'), 
      t('searchOrder.prompt'),  
      {  
        confirmButtonText: t('searchOrder.yes'), 
        cancelButtonText: t('searchOrder.cancel'),
        type: 'warning',  
      } 
    ); 
    if (confirmResult === 'confirm') {
      const response = await request.post("/cacheGlass/edgStorageCageDetails/removeEdgDetails?glassId="+encodeURIComponent(row.glassId))
    if (response.code === 200) {
     ElMessage.success(response.message);
      } else {
      ElMessage.error(response.message);
      }  
    }  
  } catch (error) {
  }  
}; 
const rowClassName = ({ row }) => {
  // 根据 enableState 设置行的 CSS 类
  return row.slot % 2 === 0 ? 'success-row' : '';
};
// 样式部分
const styles = `
  .success-row {
    --el-table-tr-bg-color: var(--el-color-info-light-9);
  }
`;
// 动态添加样式到组件
const styleElement = document.createElement('style');
styleElement.textContent = styles;
document.head.appendChild(styleElement);
 
const optionsa = [
  {
    value: 0,
    label: t('hellow.starttask'),
  },
  {
    value: 1,
    label: t('searchOrder.endtask'),
  }
]
const optionsb = [
  {
    value: 1,
    label: t('sorter.advancetask'),
  },
  {
    value: 2,
    label: t('sorter.outputtasks'),
  },
  {
    value: 3,
    label: t('sorter.straighttasks'),
  }
]
function getStatusTypea(taskType) {
  switch (taskType) {
    case 1:
      return 'info';
    case 2:
      return 'success';
    case 3:
      return 'danger';
  }
}
function getStatusTexta(taskType) {
  switch (taskType) {
    case 1:
      return t('sorter.advancetask');
    case 2:
      return t('sorter.outputtasks');
    case 3:
      return t('sorter.straighttasks');
  }
}
function getStatusTypeb(taskState) {
  switch (taskState) {
    case 0:
      return 'info';
    case 1:
      return 'success';
  }
}
function getStatusTextb(taskState) {
  switch (taskState) {
    case 0:
      return t('hellow.starttask');
    case 1:
      return t('searchOrder.endtask');
  }
}
// 格式化时间戳为年月日时间字符串的函数
function formatTimestamp(timestamp) {
  const date = new Date(timestamp);
  const year = date.getFullYear();
  const month = String(date.getMonth() + 1).padStart(2, '0'); // 月份从0开始，需要加1，并补零
  const day = String(date.getDate()).padStart(2, '0'); // 补零
  const hours = String(date.getHours()).padStart(2, '0'); // 补零（如果需要显示时间）
  const minutes = String(date.getMinutes()).padStart(2, '0'); // 补零（如果需要显示时间）
  const seconds = String(date.getSeconds()).padStart(2, '0'); // 补零（如果需要显示时间）
  return `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
}
  onUnmounted(() => {
    if (socket) {
    closeWebSocket(socket);
    }
    });
onBeforeUnmount(() => {
  closeWebSocket();
});
</script>
<template>
  <div style="height: 500px;">
    <el-card style="flex: 1;margin-left: 10px;margin-top: 10px;">
    <el-button style="margin-bottom: 15px;margin-left: 20px;" @click="handlehistorical" type="primary">{{ $t('searchOrder.historicaltasks') }}</el-button>
    <el-button style="margin-bottom: 15px;margin-left: 20px;" @click="handleptask()" type="warning">{{ $t('searchOrder.partask') }}</el-button>
    <el-button style="margin-bottom: 15px;margin-left: 20px;" @click="successfull()" type="success">{{ $t('searchOrder.successfullyprocessed') }}</el-button>
    <div style="position: relative; width: 100%; height: 100%;"> <!-- 添加相对定位 -->
  <div style="position: absolute; margin-top: 28px; left: 400px; display: flex; z-index: 10;"> <!-- 添加绝对定位 -->
    <div>{{ $t('searchOrder.projectnumber') }}</div>
    <div style="margin-left: 135px;">{{ $t('hellow.flowCardId') }}</div>
    <div style="margin-left: 152px;">{{ $t('searchOrder.glassID') }}</div>
    <div style="margin-left: 135px;">{{ $t('searchOrder.width') }}</div>
    <div style="margin-left: 169px;">{{ $t('searchOrder.height') }}</div>
    <div style="margin-left: 162px;">{{ $t('searchOrder.thickness') }}</div>
    <div style="margin-left: 135px;">{{ $t('hellow.operate') }}</div>
  </div>
    <div style="width: 98%; height: calc(100% - 35px); overflow-y: auto;">
      <el-table
      ref="table"
      style="margin-top: 20px; height: 300px;"
      :data="tableDataa"
      :header-cell-style="{ background: '#F2F3F5', color: '#1D2129' }"
      row-key="id"
  >
    <el-table-column prop="slot" align="center" :label="$t('sorter.gridnumber')" min-width="10" />
          <el-table-column
            align="center"
            :label="$t('sorter.startstatus')"
            min-width="10"
            prop="enableState"
          >
          <template #default="scope">
            <el-tag
              :type="scope.row.enableState === 1 ? 'success' : 'warning'"
            >
              {{ scope.row.enableState === 1 ? $t('sorter.start') : $t('sorter.disable') }}
            </el-tag>
          </template>
      </el-table-column>
        <el-table-column>
    <template #default="props">
      <el-table 
      :header-cell-style="{ background: '#F2F3F5', color: '#1D2129' }"
      :data="props.row.details" style="width: 100%;height: 70px;">
        <el-table-column prop="engineerId" align="center" min-width="80" />
          <el-table-column prop="flowCardId" align="center" min-width="80" />
          <el-table-column prop="glassId" align="center" min-width="80" />
          <el-table-column prop="width" align="center" min-width="80" />
          <el-table-column prop="height" align="center" min-width="80" />
          <el-table-column prop="thickness" align="center" min-width="80" />
    <el-table-column fixed="right" align="center" width="150">
        <template #default="scope">
          <el-button type="text" plain @click="handletake(scope.row)">{{ $t('searchOrder.breakage') }}</el-button>
          <el-button type="text" plain @click="handleBindRack(scope.row)">{{ $t('searchOrder.takeout')}} </el-button>
          <el-button type="text" plain @click="handledelete(scope.row)">{{ $t('searchOrder.delete')}} </el-button>
        </template>
      </el-table-column>
      </el-table>
      </template>
    </el-table-column>
  </el-table>
 </div>
 </div>
      <div style="width: 98%; height: calc(100% - 35px); overflow-y: auto;margin-top: 15px;">
        <el-table height="90" ref="table" 
        @selection-change="handleSelectionChange"
        :data="tableDatab" :header-cell-style="{background:'#F2F3F5 ',color:'#1D2129'}">
        <el-table-column prop="glassIdIn" align="center" :label="$t('searchOrder.intoglassid')" min-width="80" />
      <el-table-column prop="glassIdOut" align="center" :label="$t('searchOrder.outputglassID')" min-width="80" />
          <el-table-column prop="currentCell" align="center" :label="$t('sorter.layernow')" min-width="80" />
          <el-table-column prop="startCell" align="center" :label="$t('processCard.layer')" min-width="120" />
          <el-table-column
            align="center"
            :label="$t('film.taskstatus')"
            min-width="80"
            prop="taskState"
          >
          <template #default="scope">  
        <el-tag :type="getStatusTypeb(scope.row.taskState)">  
          {{ getStatusTextb(scope.row.taskState) }}  
        </el-tag>  
      </template> 
          </el-table-column>
          <el-table-column
            align="center"
            :label="$t('film.enabletype')"
            min-width="80"
            prop="taskType"
          >
          <template #default="scope">  
        <el-tag :type="getStatusTypea(scope.row.taskType)">  
          {{ getStatusTexta(scope.row.taskType) }}  
        </el-tag>  
      </template> 
          </el-table-column>
          <el-table-column prop="formattedCreateTime" align="center" :label="$t('film.createtime')" min-width="120" />
          <el-table-column prop="formattedupdateTime" align="center" :label="$t('sorter.updateTime')" min-width="120" />
        </el-table>
      </div>
    </el-card>
  <div class="awatch">
    <img src="../../assets/woshihuancun.png" alt="" style="width: 50%;height: 100%;margin-left: 25%;margin-top: 5px;position: relative;"> 
    <div style="position: relative; width: 500px;height: 95px;margin-top: -227px;margin-left: 615px;">
    <div  
      v-for="(rect, index) in adjustedRects"
      v-show="rect.showRect"
      :key="rect"  
      :style="{ position: 'absolute', 
       top: `${rect.id}px`, left: `-85px`, width: `435px`, height: `3px`,
      backgroundColor: '#409EFF'
       }"  
    >
  </div>
</div>
  </div>
</div>
<!-- 历史任务 -->
<el-dialog v-model="blindb" top="5vh" width="95%" @close="iframeUrl=''">
     <iframe 
     :src="iframeUrl" 
     marginwidth="2000px"
     marginheight="2000px"
     width="100%" 
     height="750px" 
     frameborder="0"
     ></iframe>
  </el-dialog>
</template>
<style scoped>
#dt { display:block; float:left;line-height: 20px;margin-left: 100px;}
#dta { display:block; float:left;line-height: 20px;margin-left: 80%;}
#dialog-footer{
  text-align: center;
  margin-top: -15px;
}
#message{
  text-align: center;
  align-items: center;
  color: black;
   width: 200px;
   height: 100px;
   background-color: #337ecc;
   margin-left: 28%;
}
.awatch{
  height: 350px;
  width: 1500px;
  max-width: 100%;
  margin-left: 10%
}
</style>
